unit frmMain_;

//This Sample project was do based on
// Sample code for Logger32 v3.30 External Interface  in a Visual Studio 5.0
//on the page for Logger32  ---> http://www.logger32.net/support.html
//and this is for cooperating with Logger32 via Messages 

interface

uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ImgList, ToolWin, ExtCtrls, CheckLst, Menus,
  ActiveX, Buttons, Mask;

function AppActivate(WindowName : PChar) : boolean; overload;

type
  TfrmMain = class(TForm)
    Label1_1:	TLabel;
    Label2:	TLabel;
    Timer:	TTimer;
    sndText:	TEdit;
    Command1:	TButton;
    Command3:	TButton;
    Label1_0: TLabel;
    Command4: TButton;
    Command2: TButton;
    Command5: TButton;
    Edit1: TEdit;
    TextBox: TRichEdit;
    procedure TextBoxChange(Sender: TObject);
    procedure Command5Click(Sender: TObject);
    procedure Command2Click(Sender: TObject);
    procedure Command4Click(Sender: TObject);
    procedure Command1Click(Sender: TObject);
    procedure Command3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Form_Unload(var Cancel: Smallint);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure TimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }

  public
    { Public declarations }

    Label1:	array[0..2] of TLabel;	// Control array
    procedure CreateParams(var Params: TCreateParams);override;

  end;

var
  frmMain: TfrmMain;
  WindowHandle : HWND; //longint; //HWND;

implementation

uses Module1;

{$R *.dfm}
{----------}
procedure TfrmMain.CreateParams(var Params: TCreateParams);
 //procedura is calling as first after start Sample.exe -- not needs to call it from this module
 //window frmMain is setting as child to parent Logger32 window
begin
  //sleep(5000) ; //1000 msec
  inherited CreateParams(Params);
  with Params do begin
    //Style:= WS_CHILD;
    //ExStyle := ExStyle or WS_EX_TOPMOST;
    L32hWnd := FindWindowVB('', 'Logger32');
    if L32hWnd > 0  then
      WndParent := L32hWnd;
    //L32hwnd os handler parent windows Logger32  
    //Style:= WS_CLIPSIBLINGS; //WS_CHILD;
    ExStyle := ExStyle or WS_EX_APPWINDOW; //WS_EX_TOPMOST;
    //ExStyle := ExStyle or WS_EX_APPWINDOW OR WS_EX_TRANSPARENT or WS_EX_TOPMOST; ze transparent

   //WndParent := GetDesktopwindow;
  end;
end;
{-------------}

	//=========================================================
procedure TfrmMain.Command1Click(Sender: TObject);
var
	sTemp: AnsiString;
        IParam: smallint;
begin
	sTemp := sndText.Text;
	// WM_SETTEXT = &HC
        IParam := Integer(sTemp);
	if (Length(sTemp)>0) and (Logger32TextBoxhWnd<>0)  then
            //SendMessageVB(Logger32TextBoxhWnd, $C, 0, sTemp);
            sendmessage(Logger32TextBoxhWnd,WM_SetText,0,longint(sTemp));
	AppActivate('Logger32');
end;

procedure TfrmMain.Command2Click(Sender: TObject);
begin
 PostMessage(L32hWnd, L32Msg, 25, 1);
 PostMessage(L32hWnd, L32Msg, 26, 1);
 AppActivate('Logger32');
end;

procedure TfrmMain.Command3Click(Sender: TObject);
begin
 PostMessage(L32hWnd, L32Msg, 12, 0);
 AppActivate('Logger32');
end;

procedure TfrmMain.Command4Click(Sender: TObject);
begin
 PostMessage(L32hWnd, L32Msg, 11, 0);
 AppActivate('Logger32');
end;

procedure TfrmMain.Command5Click(Sender: TObject);
begin
 PostMessage(L32hWnd, L32Msg, 25, 0);
 PostMessage(L32hWnd, L32Msg, 26, 0);
 AppActivate('Logger32');
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
 GhW := handle; //program's Sample windows handle  --> own handler
 Timer.Enabled := false;
 rejectRetry := 200; // Establish connection delay in milliseconds
 isLogger32There := 5000; // Look for Logger32 every xxxx milliseconds
  // rejectRetry and isLogger32There MUST be different
 setHook();
 connectToLogger32();
end;

procedure TfrmMain.Form_Unload(var Cancel: Smallint);
var WParam : integer;
    Iparam : string;
begin
 unHook();
  // If you have PTT control, relinquish control of the PTT
   // SendMessageVB L32hWnd, L32Msg, 6, 0&
    // Only if connected then tell Logger32 you're shutting down
 WParam :=4;
 Iparam := '0';
  //if Connected then SendMessageVB(L32hWnd, L32Msg, WParam, 0); //dont compile
  if Connected then SendMessageVB(L32hWnd, L32Msg, WParam, Iparam);
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);

var
        Cancel: Smallint;
begin
        Cancel := 0;

        Form_Unload(Cancel);
        If Cancel<>0 Then CanClose := false;
end;

procedure TfrmMain.TextBoxChange(Sender: TObject);
//TexBox was seletected as type TRichEdit . It is the better perform condition as there are need
//If your Delphi not have TRichEdit component - you can use  TEdit component.
var
	SelStart: Longint;
        CallsignExtrac , QSL_ViaExtrac: string;
        s: string;
        PosCall , PosQSL_Via : integer;
begin
if TextBox.Text <> '' then
  begin
   TextBox.SelStart := Length(TextBox.Text);
   //s:= StringReplace(TextBox.Text,' ', #12+ #13,[rfReplaceAll, rfIgnoreCase]);
   //TextBox.Text:=s;
    (*
           {? TextBox. }		SelStart := Len; {? TextBox. } Text(); {? ) }
		// do whatever processing you like here to
		// extract the ADIF field
           *)

   CallsignExtrac := '';
   PosCall :=Pos('<CALL',TextBox.Text);
   if PosCall > 0
    then begin
          CallsignExtrac :=copy(TextBox.Text, Pos('>',TextBox.Text)+1,
                                StrToInt(Copy(TextBox.Text,7,Pos('>' ,TextBox.Text) - 7)));
          Edit1.Text:=CallsignExtrac;
         end ;
   (*
   PosQSL_Via :=Pos('<QSL_VIA',TextBox.Text);
   if PosQSL_Via > 0
    then begin
           QSL_ViaExtrac :=copy(TextBox.Text, Pos('>',TextBox.Text)+1,
                                StrToInt(Copy(TextBox.Text,10,Pos('>' ,TextBox.Text) - 10)));
          //Edit2.Text:=QSL_ViaExtrac;
          end;
     *)
 end;
end;

procedure TfrmMain.TimerTimer(Sender: TObject);
begin
 if Timer.Interval=isLogger32There
  then begin
        L32hWnd := FindWindowVB('', 'Logger32');
        if L32hWnd=0
         then Exit
         else begin
               Self.Caption := 'Found Logger32';
               Timer.Interval := 0;
               Timer.Enabled := false;
               L32Msg := RegisterWindowMessage('Logger32 1');
               tBuffer := 'Logger32 1';
               PostMessage(L32hWnd, L32Msg, 1, GhW);
              end;
	end
   else begin
         if L32Msg=RegisterWindowMessage('Logger32 1')
           then begin
	         tBuffer := 'Logger32 2';
		 L32Msg := RegisterWindowMessage('Logger32 2');
		 PostMessage(L32hWnd, L32Msg, 1, GhW);
		 frmMain.Label2.Caption := 'Attempting connection with Logger32 2';
		end
            else if L32Msg=RegisterWindowMessage('Logger32 2')
                   then begin
		         tBuffer := 'Logger32 3';
			 L32Msg := RegisterWindowMessage('Logger32 3');
			 PostMessage(L32hWnd, L32Msg, 1, GhW);
			 frmMain.Label2.Caption := 'Attempting connection with Logger32 3';
		        end
                   else if L32Msg=RegisterWindowMessage('Logger32 3')
                         then begin
                         	tBuffer := 'Logger32 4';
		          	L32Msg := RegisterWindowMessage('Logger32 4');
			        PostMessage(L32hWnd, L32Msg, 1, GhW);
		         	frmMain.Label2.Caption := 'Attempting connection with Logger32 4';
		              end
                          else if L32Msg=RegisterWindowMessage('Logger32 4')
                                  then begin
             			        tBuffer := 'Logger32 5';
			                L32Msg := RegisterWindowMessage('Logger32 5');
			                PostMessage(L32hWnd, L32Msg, 1, GhW);
			                frmMain.Label2.Caption := 'Attempting connection with Logger32 5';
		                       end
                                  else if L32Msg=RegisterWindowMessage('Logger32 5')
                                         then begin
			                       Timer.Interval := 0;
			                       Timer.Enabled := false;
                                               Application.MessageBox(PCHAR('Unable to connect to Logger32.  I tried 5 different registered messages and all were rejected'),
                                                                      PCHAR('Too busy'), MB_OK);
                                               Self.Caption := 'Connection failed.  Too busy';
                                               frmMain.Label2.Caption := 'Failed to connect to Logger32';
                                              end;
	 Timer.Interval := 0;
	 Timer.Enabled := false;
	end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
	ZeroMemory(@Label1, SizeOf(Label1));
	Label1[1] := Label1_1;
	Label1[0] := Label1_0;
        //frmMain.Parent:='Logger32';
end;
{------------}
{AppActivate

This is used to set the current input focus to a given window using its
name.  This is especially useful for ensuring a window is active before
sending it input messages using the SendKeys function.  You can specify
a window's name in its entirety, or only portion of it, beginning from
the left.

}
 (*
var
  WindowHandle : HWND;
 *)
{---------}
function EnumWindowsProc(WHandle: HWND; lParam: LPARAM): BOOL; export; stdcall;
var
  WindowName : array[0..MAX_PATH] of char;
begin
  {Can't test GetWindowText's return value since some windows don't have a title}
  GetWindowText(WHandle,WindowName,MAX_PATH);
  Result := (StrLIComp(WindowName,PChar(lParam), StrLen(PChar(lParam))) <> 0);
  If (not Result) then WindowHandle:=WHandle;
end;
{---------}
function AppActivate(WindowHandle : HWND) : boolean; overload;
var IParam:smallint;
begin
  try
    IParam :=WindowHandle;
    SendMessage(WindowHandle, WM_SYSCOMMAND, SC_HOTKEY, IParam);
    SendMessage(WindowHandle, WM_SYSCOMMAND, SC_RESTORE, IParam);
    result := SetForegroundWindow(WindowHandle);
  except
    on Exception do Result:=false;
  end;
end;
{---------}
function AppActivate(WindowName : PChar) : boolean; overload;
begin
  try
    Result:=true;
    WindowHandle:=FindWindow(nil,WindowName);
    If (WindowHandle=0) then EnumWindows(@EnumWindowsProc,Integer(PChar(WindowName)));
    If (WindowHandle<>0) then begin
      SendMessage(WindowHandle, WM_SYSCOMMAND, SC_HOTKEY, WindowHandle);
      SendMessage(WindowHandle, WM_SYSCOMMAND, SC_RESTORE, WindowHandle);
      SetForegroundWindow(WindowHandle);  //do Foreground for Logger32 and Sample is dissapears
    end else Result:=false;
  except
    on Exception do Result:=false;
  end;
end;
{---------}

end.
